<template>
  <div class="broker-table">
    <VTextField
      v-model="search"
      class="broker-table__search"
      label="Search by Country"
    />
    <VDataTable
      :headers="headers"
      :items="filteredBrokers"
      class="broker-table__data-table"
    >
      <template
        v-slot:item.logo="{
          item: {
            columns: { logo },
          },
        }"
      >
        <v-img :src="logo" class="broker-table__logo" height="50"></v-img>
      </template>
    </VDataTable>
  </div>
</template>

<script lang="ts">
import store from "@/store";
import { BrokerDto } from "@/interfaces/BrokerDto";

import { VDataTable } from "vuetify/lib/labs/components.mjs";
import { defineComponent, ref, computed, onMounted } from "vue";

export default defineComponent({
  setup() {
    const search = ref("");

    const headers = [
      { title: "Logo", align: "center", key: "logo", sortable: false },
      { title: "Name", align: "center", key: "name" },
      { title: "Contact", align: "center", key: "contact" },
      { title: "Country", align: "center", key: "country" },
    ];
    const filteredBrokers = computed(() => {
      const searchTerm = search.value.toLowerCase();
      return searchTerm
        ? store.state.brokersList.filter((broker: BrokerDto) => {
            return broker.country.toLowerCase().includes(searchTerm);
          })
        : store.state.brokersList;
    });

    onMounted(() => {
      store.dispatch("getBrokersList");
    });
    return {
      search,
      headers,
      filteredBrokers,
    };
  },
  components: { VDataTable },
});
</script>

<style lang="scss" scoped>
/* I wrote this just for showing how to use scss. In fact I do not need to write any style for data table */

.broker-table {
  &__search {
    /* Styles for the search input */
    margin-bottom: 1rem;
  }

  &__data-table {
    /* Styles for the data table */
    max-width: 100%;
    overflow-x: auto;

    &__logo {
      /* Styles for the logo */
    }
  }
}

@media screen and (max-width: 600px) {
  .broker-table {
    &__search {
      /* Styles for the search input */

      width: 100%;
    }
    &__data-table {
      /* Adjust styles for small screens */
    }
  }
}
</style>
